Summer Training day6 codeforces292D并查集合并

来源:互联网 发布:淘宝店铺装模板 编辑:程序博客网 时间:2024/06/13 18:33

D. Connected Components
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

We already know of the large corporation where Polycarpus works as a system administrator. The computer network there consists of ncomputers and m cables that connect some pairs of computers. In other words, the computer network can be represented as some non-directed graph with n nodes and m edges. Let's index the computers with integers from 1 to n, let's index the cables with integers from 1 to m.

Polycarpus was given an important task — check the reliability of his company's network. For that Polycarpus decided to carry out a series of k experiments on the computer network, where the i-th experiment goes as follows:

  1. Temporarily disconnect the cables with indexes from li to ri, inclusive (the other cables remain connected).
  2. Count the number of connected components in the graph that is defining the computer network at that moment.
  3. Re-connect the disconnected cables with indexes from li to ri (that is, restore the initial network).

Help Polycarpus carry out all experiments and for each print the number of connected components in the graph that defines the computer network through the given experiment. Isolated vertex should be counted as single component.

Input

The first line contains two space-separated integers nm (2 ≤ n ≤ 500; 1 ≤ m ≤ 104) — the number of computers and the number of cables, correspondingly.

The following m lines contain the cables' description. The i-th line contains space-separated pair of integers xiyi (1 ≤ xi, yi ≤ nxi ≠ yi)— the numbers of the computers that are connected by the i-th cable. Note that a pair of computers can be connected by multiple cables.

The next line contains integer k (1 ≤ k ≤ 2·104) — the number of experiments. Next k lines contain the experiments' descriptions. The i-th line contains space-separated integers liri (1 ≤ li ≤ ri ≤ m) — the numbers of the cables that Polycarpus disconnects during the i-th experiment.

Output

Print k numbers, the i-th number represents the number of connected components of the graph that defines the computer network during the i-th experiment.

Examples
input
6 51 25 42 33 13 661 32 51 55 52 43 3
output
456342
题解:

这题我能想到的最暴力的解法就是每次询问的时候都重新一条一条边的建图,但这样复杂度显然会爆炸。其实并非每条边都是有用处的,想想,500个点,只需要499条边就可以将他们全部构成连通块,剩下的边都是没有用处的。我们从这个思路出发,可以构建1e4个[1,1],[1,2],....,[1,1e4]个并查集,再构建1e4个[1e4,1e4],[1e4-1,1e4]...[1,1e4]这些个并查集。建立这些并查集的目的就是将不论多少条边都压缩到500的复杂度。(因为每个并查集最大只有500个点)

这样的话用的时候只需要从左边挑选出一个并查集从右边挑选出一个并查集进行合并就可以了,合并的复杂度为500.

代码:

#include <cstdio>const int MAXN = 505;struct dsu{int parent[MAXN];void init(){for(int i = 0; i < MAXN;i++){parent[i]  = i;}}int find(int x){return parent[x] == x ? x : parent[x] = find(parent[x]);}void join(int x,int y){int px = find(x);int py = find(y);if(px != py) parent[px] = py;}}L[10007],R[10007];int n,m,k;int l[10007],r[10007];int main(){scanf("%d%d",&n,&m);for(int i = 1;i <= m;i++){scanf("%d%d",&l[i],&r[i]);}L[0].init();for(int i = 1;i <= m;i++){L[i] = L[i-1];L[i].join(l[i],r[i]);}R[m+1].init();for(int i = m;i >= 0;i--){R[i] = R[i+1];R[i].join(l[i],r[i]);}scanf("%d",&k);for(int i = 0;i < k;i++){int a,b;scanf("%d%d",&a,&b);dsu nd = L[a-1];for(int t = 0;t < MAXN;t++) nd.join(nd.find(t),R[b+1].find(t));int ans = 0;for(int i = 1;i <= n;i++){if(i == nd.find(i)) ans ++;}printf("%d\n",ans);}}



原创粉丝点击